Subject: bug#79035: Remove micro-optimization for Funintern for performance

From: Stefan Monnier <[email-masked]>
Date: Thu, 17 Jul 2025 11:09:21 -0400

> (lread.c): Remove static variable oblookup_last_bucket_number.  Removal
> appears to reduce execution time of obarray functions by about 6%, while
> the variable was only used to avoid a redundant lookup in the rarely
> called Funintern.

[ Actually, it's not even a full lookup that's avoided, it's only the
  computation of the hash index.  ]

Yeah, this static var is ugly, I'm in favor of removing it.

BTW, looking at the code of `Funintern` I get the impression that
`oblookup_considering_shorthand` is wrong when the argument is a symbol:
we should take shorthand into account only when passed a string.

        Stefan